$regfile = "m644pdef.dat"
'$regfile = "m32def.dat"
'$regfile = "m16def.dat"

$framesize = 60
$hwstack = 60
$swstack = 60

$crystal = 16000000

Config Sda = Portc.1
Config Scl = Portc.0
$baud = 9600

Dim D As Byte , M As Byte , Y As Byte
Dim Wd As Byte
Dim H As Byte , I As Byte , S As Byte
Dim S_old As Byte
S_old = 255

Dim Wd_names(7) As String * 4
Wd_names(1) = " Nd"
Wd_names(2) = "Pon"
Wd_names(3) = " Wt"
Wd_names(4) = " Sr"
Wd_names(5) = "Czw"
Wd_names(6) = " Pt"
Wd_names(7) = " Sb"

I2cinit
'inicjalizacja magistrali I2C

Waitms 1

I2cstart
'adres ukadu do zapisu
I2cwbyte &HA2
'wybieramy zapis do rejestru kontroli wyjcia CLK
I2cwbyte &H0D
'wczamy generowanie sygnau o czstotliwoci 1Hz
I2cwbyte &B10000011
I2cstop

Config Int0 = Falling
On Int0 Zegar
Config Pind.2 = Input
Set Portd.2

Gosub Zegar

S = S And &B01111111
I = I And &B01111111
H = H And &B00111111

D = D And &B00111111
Wd = Wd And &B00000111
Wd = Wd + 1
M = M And &B00011111


Print
Print
Print Bcd(h) ; ":" ; Bcd(i) ; ":" ; Bcd(s) ; "  ";
Print Wd_names(wd) ; " ";
Print Bcd(d) ; "-" ; Bcd(m) ; "-" ; Bcd(y) ; "  "

Input "Ustawic inny czas? (0-NIE   1-TAK): " , S
If S <> 0 Then

   Input "Rok (00-99): " , Y
   Input "Miesiac: " , M
   Input "Dzien: " , D
   Print "Dzien tygodnia "
   For I = 1 To 7 Step 1
      Print I ; "->" ; Wd_names(i)
   Next I
   Input "Podaj liczbe  zakresu (1-7): " , Wd
   Input "Godzina: " , H
   Input "Minuta: " , I
   Input "Sekunda: " , S

   Y = Makebcd(y)
   M = Makebcd(m)
   D = Makebcd(d)
   H = Makebcd(h)
   I = Makebcd(i)
   S = Makebcd(s)

   Wd = Wd - 1

   I2cstart
   I2cwbyte &HA2
   'Adres zegara do zapisu
   I2cwbyte 2
   'Numer rejestru (wg. dokumentacji tu rejestr nr 2 to rejestr sekund)
   I2cwbyte S
   I2cwbyte I
   I2cwbyte H
   I2cwbyte D
   I2cwbyte Wd
   I2cwbyte M
   I2cwbyte Y
   I2cstop
   Print "Czas ustawiony"

End If

Enable Int0
Enable Interrupts


Do
   If S <> S_old Then
      S_old = S
       S = S And &B01111111
       I = I And &B01111111
       H = H And &B00111111

       D = D And &B00111111
       Wd = Wd And &B00000111
       Wd = Wd + 1
       M = M And &B00011111
       Print Bcd(h) ; ":" ; Bcd(i) ; ":" ; Bcd(s) ; "  ";
       Print Wd_names(wd) ; " ";
       Print Bcd(d) ; "-" ; Bcd(m) ; "-" ; Bcd(y) ; "  "
    End If
Loop
End

Zegar:
    I2cstart
    'Sygna START
    I2cwbyte &HA2
    'Adres zegara do zapisu
    I2cwbyte 2
    'Numer rejestru (wg. dokumentacji tu rejestr nr 2 to rejestr sekund)
    I2cstart
    'Sygna START
    I2cwbyte &HA3
    'Adres zegara do odczytu
    I2crbyte S , Ack
    'Odczyt sekund z rejestru 2
    I2crbyte I , Ack
    'Odczyt minut z rejestru 3
    I2crbyte H , Ack
    'Odczyt godzin z rejestru 4
    I2crbyte D , Ack
    'Odczyt dni z rejestru 5
    I2crbyte Wd , Ack
    'Odczyt dnia tygodnia z rejestru 6
    I2crbyte M , Ack
    'Odczyt miesica z rejestru 7
    I2crbyte Y , Nack
    'Odczyt roku z rejestru 8
    I2cstop
Return