/*
 * ADC.c
 *
 * Created: 2014-02-12 16:46:07
 *  Author: Piotr
 */ 
#include "ADC.h"

void ADC_init(void){
	ADMUX |= (1<<REFS0);//ustawiam napicie odniesienia na AVCC (napicie zasilania ukadu ~5V)
	ADCSRA |= (1<<ADPS0)|(1<<ADPS1)|(1<<ADPS2);//ustawienie prescalera na 128 = czstotliwo taktowania 125kHz
	ADCSRA |= (1<<ADEN);//wczenie przetwornika
	
}
uint16_t ADC_get(uint8_t channel){
	ADMUX=(ADMUX&0b11100000)|(channel&0b00011111);//ustawiam kana
	ADCSRA |= (1<<ADSC);//rozpoczynam konwersj
	while(ADCSRA&(1<<ADSC));//czekamy na zakoczenie tej konwersji
	return ADC;
}
