/*
 * main.c
 *
 *  Created on: 24-05-2013
 *      Author: Piotr Rzeszut
 *  
 * Description: Przykad obsugi 3 kanaw PWM do sterowania diod RGB w zestawie EvB5.1 v5
 */
#include <avr/io.h>
#include <util/delay.h>


int main(void){
	
	DDRB |= (1<<PB3)|(1<<PB4);
	DDRD |= (1<<PD5);//ustawiam piny OC0A, OC0B i OC1A jako wyjcia

	TCCR0A |= (1<<COM0A0)|(1<<COM0A1)|(1<<COM0B0)|(1<<COM0B1)|(1<<WGM00);
	//Ustawiamy odpwiedni tryb pracy wyj OC dziki temu warto 255 bdzie oznaczaa maksymaln jasno
	//Wybieramy tryb Pahse Correct PWM

	TCCR0B |= (1<<CS00);//wczamy timer z preskalerem 1



	TCCR1A |= (1<<COM1A0)|(1<<COM1A1)|(1<<WGM10);
	//Ustawiamy odpwiedni tryb pracy wyj OC dziki temu warto 255 bdzie oznaczaa maksymaln jasno
	//Wybieramy tryb Pahse Correct PWM z rozdzielczoci 8-bit

	TCCR1B |= (1<<CS10);//wczamy timer z preskalerem 1

	OCR0A=255;
	OCR0B=128;
	OCR1A=0;

	while(1){
		OCR0A++;
		OCR0B++;
		OCR1A=((OCR1A+1)&0x00FF);
		_delay_ms(10);
	}
	return 0;
}
