/*
 * main.c
 *
 * Created: 2014-02-12 16:16:13
 *  Author: Piotr
 *
 * Description: Program demonstrujcy dziaanie przetwornika ADC i wywietlacza LCD
 */ 


#include <avr/io.h>
#include <stdio.h>

#include "HD44780.h"
#include "ADC.h"


int main(void)
{
	LCD_Initalize();//inicjalizacja LCD
	
	ADC_init();
	
	LCD_GoTo(0,0);//ustawiamy si w pierwszej kolumnie i pierwszym wierszu
	LCD_WriteText("LCD ADC display");
	
	LCD_GoTo(0,1);//ustawiamy si w pierwszej kolumnie i drugim wierszu
	LCD_WriteText("A0=     A1=    ");
	
	char buffer[6];
	uint16_t val;
	
    while(1)
    {
        val=ADC_get(0);//pobieram odczyt
        sprintf(buffer,"%04d",val);//konwertuj go na cig znakw i dopisuj zera
        LCD_GoTo(3,1);//ustawiam si na pocztku pola, w ktrym ma by widoczny wynik
        LCD_WriteText(buffer);//wywietlam go (nadpisuj poprzedni)
		
		val=ADC_get(1);
		sprintf(buffer,"%04d",val);
		LCD_GoTo(11,1);
		LCD_WriteText(buffer);
    }
}